'use strict';
var dailyReport = require('../services/dailyReportService.js');
const { body } = require('express-validator')

// exports.validate = (method) => {
//   switch (method) {
//     case 'adddailyReport': {
//      return [
//         body('waiter_key_number', 'waiter_key_number is required.').not().isEmpty(),
//        ]
//     }
//   }
// }

const { validationResult } = require('express-validator');

exports.addDailyReport = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  dailyReport.addDailyReport(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.listDailyReport = function(req, res){
  dailyReport.listDailyReport(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getDailyReport = function(req, res){
  dailyReport.getDailyReport(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getReportDates = function(req, res){
  dailyReport.getReportDates(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.updateDailyReport = function(req, res){
  dailyReport.updateDailyReport(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.deleteDailyReport = function(req, res){
  dailyReport.deleteDailyReport(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};