'user strict';
var sql = require('./../../conf/db.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
var jwt = require('jsonwebtoken');
var logsFile = require('./logsModel.js');
var category = function(use){

};

category.addCategory = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                if(body.parent_id){
                    parent_id=body.parent_id;
                }
                else{
                    parent_id=0;
                }
                sql.query("SELECT * FROM categories WHERE cat_number='"+body.cat_number+"' AND user_id='"+body.user_id+"' AND is_deleted='0'",function(errss,ress){
                    if(ress[0]){
                        response = {
                            'status':'Exist',
                            'message':'Category already exist',
                        }
                        resolve(response)
                    }
                    else{
                        sql.query("INSERT INTO categories (`user_id`, `parent_id`, `cat_number`, `name`, `account_number_charges_id`, `account_number_profits_id`, `vat_code_id`, `created_at`, `updated_at`)  VALUES ('"+body.user_id+"','"+parent_id+"','"+body.cat_number+"','"+body.name+"','"+body.account_number_charges_id+"','"+body.account_number_profits_id+"','"+body.vat_code_id+"','"+createdDate+"','"+createdDate+"')",function(errss,ress){
                            if(!errss){    
                                var logsData={added_by:body.user_id,type:'add_category',message:'Castegory ('+body.name+') has been added',json_data:JSON.stringify({id:ress.insertId,type:'category'})}  
                                logsFile.addLogs(authorization,logsData);
                                response = {
                                    'status':'success',
                                    'message':'Category added successfully',
                                }
                            }
                            else {                                    
                                response = {
                                    'status': 'fail',
                                    'message': 'failed to add category',
                                }                                        
                            }
                            resolve(response)
                        });
                    }
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

category.getCategory = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {
            if(!err){
                //console.log("SELECT * from categories WHERE id='"+id+"'")
                sql.query("SELECT * from categories WHERE id='"+id+"'",function(errss,ress){
                        if(ress[0]){    
                            response = {
                                'status':'success',
                                data:ress[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'error to get Category',
                            }                                        
                        }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

category.listCategories = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {
            if(!err){                
                var search='1 AND ';
                if(body.cat_number)
                    search="cat_number LIKE '%"+body.cat_number.trim()+"%' AND "
                if(body.name)
                    search+="name LIKE '%"+body.name.trim()+"%' AND "
                if(body.parentId!=undefined)
                    search+="parent_id = '"+body.parentId+"' AND "
                if(body.user_id)
                    search+="user_id = '"+body.user_id+"' AND "

                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }
                //console.log(search)

               //console.log("SELECT *,(SELECT name FROM categories as parent_cat WHERE id = categories.parent_id and user_id= '"+body.user_id+"') as parent_category from categories WHERE "+search+" is_deleted='0' order by parent_category asc, "+body.orderBy+" "+body.sort);
                sql.query("SELECT *,(SELECT name FROM categories as parent_cat WHERE id = categories.parent_id and user_id= '"+body.user_id+"') as parent_category from categories WHERE "+search+" is_deleted='0' order by parent_category asc, "+body.orderBy+" "+body.sort,function(errss,ress){
                        if(ress){
                            response = {
                                'status':'success',
                                data:ress,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'error to list categories',
                            }                                        
                        }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

category.editCategory = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {            
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                if(body.parent_id){
                    parent_id=body.parent_id;
                }
                else{
                    parent_id=0;
                }
                sql.query("SELECT * FROM categories WHERE cat_number='"+body.cat_number+"' AND user_id='"+body.user_id+"' AND is_deleted='0' AND id!='"+body.id+"'",function(errss,ress){
                    if(ress[0]){
                        response = {
                            'status':'Exist',
                            'message':'Category already exist',
                        }
                        resolve(response)
                    }
                    else{
                        sql.query("UPDATE categories SET parent_id='"+parent_id+"',cat_number='"+body.cat_number+"', name='"+body.name+"', account_number_charges_id='"+body.account_number_charges_id+"', account_number_profits_id='"+body.account_number_profits_id+"', vat_code_id='"+body.vat_code_id+"', updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,ress){
                            if(!errs){    
                                var logsData={added_by:body.user_id,type:'update_category',message:'Category ('+body.name+') has been updated',json_data:JSON.stringify({id:body.id,type:'category'})}  
                                logsFile.addLogs(authorization,logsData);
                                response = {
                                    'status':'success',
                                    'message':'Successfully updated the category',
                                }
                            }
                            else{
                                response = {
                                    'status': 'error',
                                    'message': errs,
                                }
                            }
                            resolve(response)
                        });
                    }
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

category.deleteCategory = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {
            if(!err){
                //console.log("UPDATE categories SET is_deleted=1 WHERE id='"+id+"'")
                sql.query("UPDATE categories SET is_deleted=1 WHERE id='"+id+"'",function(errss,ress){
                        if(!errss){  
                            sql.query("SELECT * from categories WHERE is_deleted=1 AND id='"+id+"'",function(errss,body){
                                var logsData={added_by:body[0].user_id,type:'delete_category',message:'Category ('+body[0].name+') has been deleted',json_data:JSON.stringify({id:body[0].id,type:'category'})}  
                                logsFile.addLogs(authorization,logsData);
                            });  
                            response = {
                                'status':'success',
                                'message':'Successfully deleted the category'
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'error to delete category',
                            }                                        
                        }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 


module.exports= category;