'user strict';
var sql = require('./../../conf/db.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
var fileUpload = require('express-fileupload');
const saltRounds = 10;
var passwordHash;
var employee = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

//Add employee function
employee.add_employee = async function(authorization,body) {
    const passwordHash = await generatePassword(body.password);
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(1){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("INSERT INTO employees (full_name,job,email,phone_number,address,password,is_active,is_deleted,created_at,updated_at,profile_image) VALUES ('"+body.name+"','"+body.job+"', '"+body.email+"','"+body.phone_number+"','"+body.address+"','"+passwordHash+"', '"+body.status+"','0','"+createdDate+"','"+createdDate+"','"+body.profile_image+"')",function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully inserted the employee',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//employee list function
employee.employee_list = async function(authorization,body) {
    //console.log(body)
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(1){
                var search='1 AND ';
                if(body.name)
                    search+="full_name LIKE '%"+body.name.trim()+"%' AND "
                if(body.email)
                    search+="email LIKE '%"+body.email.trim()+"%' AND "
                if(body.phone_number)
                    search+="phone_number LIKE '%"+body.phone_number.trim()+"%' AND "  
                if(body.address)
                    search+="address LIKE '%"+body.address.trim()+"%' AND "     

                var created_at = userDefinedFunction.formatDate(body.created_at);
                var updated_at = userDefinedFunction.formatDate(body.updated_at);
                if(body.created_at && !body.updated_at)
                    search+="created_at BETWEEN '"+created_at+"' AND '"+created_at+"' AND "
                if(!body.created_at && body.updated_at)
                    search+="created_at BETWEEN '"+updated_at+"' AND '"+updated_at+"' AND "
                if(body.created_at && body.updated_at)
                    search+="created_at BETWEEN '"+created_at+"' AND '"+updated_at+"' AND "          
               
                if(body.orderBy=='name')
                    body.orderBy='full_name'
                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }
                //console.log(search)

                //console.log("SELECT * from employees WHERE "+search+" is_deleted='0' AND user_role_id="+3+" order by "+body.orderBy+" "+body.sort+"")

                sql.query("SELECT * from employees WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all employee',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//Update employee function
employee.update_employee = async function(authorization,body) {
    if(body.password){
        passwordHash = await generatePassword(body.password);
    }
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            var createdDate = userDefinedFunction.databaseFormat();
            if(1){
                var update_pass="";
                if(passwordHash){
                    update_pass="password='"+passwordHash+"', ";
                }
                sql.query("UPDATE employees SET full_name='"+body.name+"',job='"+body.job+"', address='"+body.address+"', is_active='"+body.status+"', "+update_pass+"  email='"+body.email+"',phone_number='"+body.phone_number+"',profile_image='"+body.profile_image+"',updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully updated the employee',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get employee function
employee.get_employee = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(1){
                sql.query("SELECT * from employees WHERE id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'employee not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete employee function
employee.delete_employee = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(1){
                sql.query("UPDATE employees SET is_deleted='1' WHERE id="+id+"",function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the employee',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= employee;