'user strict';
var sql = require('./../../conf/db.js');
var config = require('./../../conf/config.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
var fileUpload = require('express-fileupload'); 
const saltRounds = 10;
var passwordHash;
var staffSales = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

//Add staffSales function
staffSales.addStaffSales = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var reportId='';
                var createdDate = userDefinedFunction.databaseFormat();
                //console.log(body.daily_sales[1].cash_fields[2].total_number)
                for(let count=0;count<body.daily_sales.length;count++){
                    sql.query("SELECT id from daily_report_book order by id desc limit 1",function(errs,last_id){reportId=last_id[0].id;
                    //console.log(reportId)
                        sql.query("INSERT INTO daily_sales_staff (daily_report_book_id,waiter_id,waiter_key_number,net_sales,total_cash,amount_from_payment_methods,difference_amount,is_deleted,created_at,updated_at) VALUES ('"+reportId+"','"+body.daily_sales[count].waiter_id+"','"+body.daily_sales[count].waiter_key_number+"','"+body.daily_sales[count].daily_sales_net+"','"+body.daily_sales[count].cash+"','"+body.daily_sales[count].payment_method+"','"+body.daily_sales[count].difference+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){
                            for(var i=0;i<body.daily_sales[count].cash_fields.length;i++){
                                if(body.daily_sales[count].cash_fields[i].total_number)
                                    sql.query("INSERT INTO daily_sales_staff_cash_details (`daily_report_book_id`, `waiter_id`, `total_number`, `unit`, `amount`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+reportId+"','"+body.daily_sales[count].waiter_id+"','"+body.daily_sales[count].cash_fields[i].total_number+"','"+body.daily_sales[count].cash_fields[i].unit+"','"+body.daily_sales[count].cash_fields[i].amount+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                            }
                            for(var i=0;i<body.daily_sales[count].payment_means.length;i++){
                                if(body.daily_sales[count].payment_means[i].payment_amount)
                                    sql.query("INSERT INTO daily_sales_staff_payment_method_details (`daily_report_book_id`, `waiter_id`, `payment_method_id`, `total_number`, `description`, `amount`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+reportId+"','"+body.daily_sales[count].waiter_id+"','"+body.daily_sales[count].payment_means[i].payment_type+"','"+body.daily_sales[count].payment_means[i].payment_number+"','"+body.daily_sales[count].payment_means[i].description+"','"+body.daily_sales[count].payment_means[i].payment_amount+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                            }
                            if(!errs){    
                                response = {
                                    'status':'success',
                                    'message':'Successfully inserted the Daily Staff Report',
                                }
                            }
                            else{
                                response = {
                                    'status': 'error',
                                    'message': errs,
                                }
                            }
                            resolve(response)
                        });
                    });
                }
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//staffSales list function
staffSales.listStaffSales = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                if(body.staff_name)
                    search="users.full_name LIKE '%"+body.staff_name.trim()+"%' AND "
                if(body.waiter_key_number)
                    search+="waiter_key_number LIKE '%"+body.waiter_key_number.trim()+"%' AND "

                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }
                if(body.orderBy=='staff_name')
                {
                    body.orderBy='users.full_name'
                }

                sql.query("SELECT daily_sales_staff.id,daily_sales_staff.net_sales,daily_sales_staff.waiter_key_number,users.full_name FROM daily_sales_staff INNER JOIN users on daily_sales_staff.waiter_key_number=users.id WHERE "+search+" daily_sales_staff.is_deleted='0' order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all the Staff Sales',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//Get staffSales function
staffSales.getStaffSales = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                //console.log("res")
                sql.query("SELECT *,users.id as full_name FROM daily_sales_staff LEFT JOIN users ON waiter_key_number=users.id WHERE daily_sales_staff.daily_report_book_id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res){    
                            sql.query("SELECT id from daily_sales_staff order by id desc limit 1",function(errs,last_id){
                                sql.query("SELECT * FROM daily_sales_staff_cash_details WHERE daily_sales_staff_id='"+res.id+"'",function(errs,resCash){
                                    if(!errs){
                                        sql.query("SELECT * FROM daily_sales_staff_payment_method_details WHERE daily_sales_staff_id='"+res.id+"'",function(errs,resMethod){
                                            if(!errs){
                                                response = {
                                                    'status':'success',
                                                    data:res,
                                                    resCash:resCash,
                                                    resMethod:resMethod
                                                }
                                                resolve(response)
                                            }
                                        });
                                    }
                                });
                            });
                           
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'Daily Staff Sale not found',
                            }     
                            resolve(response)                                   
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                        resolve(response)
                    }
                   
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Update staffSales function
staffSales.updateStaffSales = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log(body)
        jwt.verify(token, 'secret', function(err, decoded) {            
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                for(let count=0;count<body.daily_sales.length;count++){
                let body_fields=body.daily_sales[count];
                    for(var i=0;i<body_fields.cash_fields.length;i++){
                        if(body_fields.cash_fields[i].total_number && body_fields.cash_fields[i].cash_id){                           
                            sql.query("UPDATE daily_sales_staff_cash_details SET `total_number`='"+body_fields.cash_fields[i].total_number+"', `unit`='"+body_fields.cash_fields[i].unit+"', `amount`='"+body_fields.cash_fields[i].amount+"', `updated_at`='"+createdDate+"' WHERE id='"+body_fields.cash_fields[i].cash_id+"'",function(errs,res){});
                         }else if(body_fields.cash_fields[i].total_number && !body_fields.cash_fields[i].cash_id){
                            sql.query("INSERT INTO daily_sales_staff_cash_details (`daily_report_book_id`, `waiter_id`, `total_number`, `unit`, `amount`, `is_deleted`, `created_at`,`updated_at`) VALUES ('"+body.id+"','"+body_fields.waiter_id+"','"+body_fields.cash_fields[i].total_number+"','"+body_fields.cash_fields[i].unit+"','"+body_fields.cash_fields[i].amount+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                         }else if(!body_fields.cash_fields[i].total_number){
                            sql.query("DELETE FROM daily_sales_staff_cash_details WHERE id='"+body_fields.cash_fields[i].cash_id+"'",function(errs,res){});
                        }
                    }
                    if(body_fields.deleted_payment_id)
                        for(var i=0;i<body_fields.deleted_payment_id.length;i++){
                            sql.query("DELETE FROM daily_sales_staff_payment_method_details WHERE id='"+body_fields.deleted_payment_id[i]+"'",function(errs,res){});
                        }
                    for(var i=0;i<body_fields.payment_means.length;i++){
                        if(body_fields.payment_means[i].payment_id)
                            sql.query("UPDATE daily_sales_staff_payment_method_details SET `payment_method_id`='"+body_fields.payment_means[i].payment_type+"', `total_number`='"+body_fields.payment_means[i].payment_number+"', `description`='"+body_fields.payment_means[i].description+"', `amount`='"+body_fields.payment_means[i].payment_amount+"', `updated_at`='"+createdDate+"' WHERE id='"+body_fields.payment_means[i].payment_id+"'",function(errs,res){});
                        else if(body_fields.payment_means[i].payment_amount)
                            sql.query("INSERT INTO daily_sales_staff_payment_method_details (`daily_report_book_id`, `waiter_id`, `payment_method_id`, `total_number`, `description`, `amount`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+body.id+"','"+body_fields.waiter_id+"','"+body_fields.payment_means[i].payment_type+"','"+body_fields.payment_means[i].payment_number+"','"+body_fields.payment_means[i].description+"','"+body_fields.payment_means[i].payment_amount+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                    }
                    for(var i=0;i<body.staff_sale_fields.length;i++){
                        if(body.staff_sale_fields[i].staff_report_id && body.staff_sale_fields[i].staff_sales){
                            //console.log("UPDATE daily_sales_staff SET net_sales='"+body_fields.daily_sales_net+"',total_cash='"+body_fields.cash+"',amount_from_payment_methods='"+body_fields.payment_method+"',difference_amount='"+body_fields.difference+"',updated_at='"+createdDate+"' WHERE id='"+body.staff_sale_fields[i].staff_report_id+"' ")
                            sql.query("UPDATE daily_sales_staff SET net_sales='"+body_fields.daily_sales_net+"',total_cash='"+body_fields.cash+"',amount_from_payment_methods='"+body_fields.payment_method+"',difference_amount='"+body_fields.difference+"',updated_at='"+createdDate+"' WHERE id='"+body.staff_sale_fields[i].staff_report_id+"' ",function(errs,res){});
                        }
                        else if(!body.staff_sale_fields[i].staff_report_id && body.staff_sale_fields[i].staff_sales){
                            //console.log("INSERT INTO daily_sales_staff (daily_report_book_id,waiter_id,waiter_key_number,net_sales,total_cash,amount_from_payment_methods,difference_amount,is_deleted,created_at,updated_at) VALUES ('"+body.id+"','"+body_fields.waiter_id+"','"+body_fields.waiter_key_number+"','"+body_fields.daily_sales_net+"','"+body_fields.cash+"','"+body_fields.payment_method+"','"+body_fields.difference+"','0','"+createdDate+"','"+createdDate+"')")
                            sql.query("INSERT INTO daily_sales_staff (daily_report_book_id,waiter_id,waiter_key_number,net_sales,total_cash,amount_from_payment_methods,difference_amount,is_deleted,created_at,updated_at) VALUES ('"+body.id+"','"+body_fields.waiter_id+"','"+body_fields.waiter_key_number+"','"+body_fields.daily_sales_net+"','"+body_fields.cash+"','"+body_fields.payment_method+"','"+body_fields.difference+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                        }
                        else if(!body.staff_sale_fields[i].staff_sales){
                            //console.log("DELETE FROM daily_sales_staff WHERE id='"+body.staff_sale_fields[i].staff_report_id+"'")
                            sql.query("DELETE FROM daily_sales_staff WHERE id='"+body.staff_sale_fields[i].staff_report_id+"'",function(errs,res){}); 
                        }
                        
                    }
                    if(1){    
                        response = {
                            'status':'success',
                            'message':'Successfully updated the daily staff sales',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                }
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete staffSales function
staffSales.deleteStaffSales = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("UPDATE daily_sales_staff SET is_deleted='1' WHERE id='"+id+"'",function(errs,res){
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the daily staff sales',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= staffSales;